#version 330 core

in vec3 frag_texcoord;
in vec2 frag_light;
in float frag_depth;

out vec4 color;

uniform sampler2DArray texture1;
uniform sampler2D light;
uniform vec3 fog_color;
uniform float fog_depth;

void main()
{
        vec4 reflected = texture(texture1, frag_texcoord);
        if (reflected.a <= 0.5) discard;
        vec3 brightness = texture(light, (frag_light + 0.5) / 16.0).xyz;
        vec3 base = reflected.xyz * brightness;
        float fog_density = pow(clamp(frag_depth / fog_depth, 0, 1), 2);
        color = vec4(mix(base, fog_color, fog_density), 1.0);
}
