
How to add a new Item Type to Voxel Garden.

[[_TOC_]]

## The Basics

You'll need the following tools:

1. a text editor
2. a sprite editor

We'll assume:

* your pack is named PACK
* your new item is named NAME
* and your desired language is LANG

You will have to edit files in:

```sh
PACK/
├── item_types.cfg
├── item_models.cfg
├── strings/
│   └── LANG.cfg
└── textures/
    └── NAME.png
```

### PACK/item_types.cfg

Each section in this file defines the properties of one item in the world.

Fun thing here is that an item just to be held in your inventory does not
require any fields, it can consist on just the `[NAME]` tag, but there are a
number of fields you might want to define.

```ini
[NAME]
place = PACK.NAME   ; places PACK.NAME cell when used
spawn = PACK.NAME   ; spawns PACK.NAME mob when used
```

### PACK/item_models.cfg

Each section in this file defines how an item displays,
both graphically and audio-wise:

```ini
[NAME]
texture = NAME.png  ; uses PACK/textures/NAME.png for display
```

### PACK/strings/LANG.cfg

Each entry in this file provides a translation string for an specific name in
the language LANG:

```ini
NAME = "Your item name here"
```

